function scores = validate_correspondence(M1, M2, corr)

    % Monitor Dice
    if isfield(corr,'corr12') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores12,scores.labels] = dice(M2.P(corr.corr12),M1.P);
        disp(['(Sp 1->2) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores12),'%.1f') '+-' num2str(100*std(scores.scores12),'%.1f') '% [' num2str(100*min(scores.scores12),'%.1f') '/' num2str(100*max(scores.scores12),'%.1f') ']']);
    end
    if isfield(corr,'corr21') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores21,scores.labels] = dice(M1.P(corr.corr21),M2.P);
        disp(['(Sp 2->1) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores21),'%.1f') '+-' num2str(100*std(scores.scores21),'%.1f') '% [' num2str(100*min(scores.scores21),'%.1f') '/' num2str(100*max(scores.scores21),'%.1f') ']']);
    end
    if isfield(corr,'corr12') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores12,scores.labels] = dice(M2.Pm(corr.corr12),M1.Pm);
        disp(['(Sp 1->2) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores12),'%.1f') '+-' num2str(100*std(scores.scores12),'%.1f') '% [' num2str(100*min(scores.scores12),'%.1f') '/' num2str(100*max(scores.scores12),'%.1f') '] <<<']);
    end
    if isfield(corr,'corr21') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores21,scores.labels] = dice(M1.Pm(corr.corr21),M2.Pm);
        disp(['(Sp 2->1) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores21),'%.1f') '+-' num2str(100*std(scores.scores21),'%.1f') '% [' num2str(100*min(scores.scores21),'%.1f') '/' num2str(100*max(scores.scores21),'%.1f') '] <<<']);
    end

    if isfield(corr,'corr12fs') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores12fs,scores.labels] = dice(M2.P(corr.corr12fs),M1.P);
        disp(['(FS 1->2) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores12fs),'%.1f') '+-' num2str(100*std(scores.scores12fs),'%.1f') '% [' num2str(100*min(scores.scores12fs),'%.1f') '/' num2str(100*max(scores.scores12fs),'%.1f') ']']);
    end
    if isfield(corr,'corr21fs') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores21fs,scores.labels] = dice(M1.P(corr.corr21fs),M2.P);
        disp(['(FS 2->1) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores21fs),'%.1f') '+-' num2str(100*std(scores.scores21fs),'%.1f') '% [' num2str(100*min(scores.scores21fs),'%.1f') '/' num2str(100*max(scores.scores21fs),'%.1f') ']']);
    end
    if isfield(corr,'corr12fs') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores12fs,scores.labels] = dice(M2.Pm(corr.corr12fs),M1.Pm);
        disp(['(FS 1->2) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores12fs),'%.1f') '+-' num2str(100*std(scores.scores12fs),'%.1f') '% [' num2str(100*min(scores.scores12fs),'%.1f') '/' num2str(100*max(scores.scores12fs),'%.1f') '] <<<']);
    end
    if isfield(corr,'corr21fs') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores21fs,scores.labels] = dice(M1.Pm(corr.corr21fs),M2.Pm);
        disp(['(FS 2->1) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores21fs),'%.1f') '+-' num2str(100*std(scores.scores21fs),'%.1f') '% [' num2str(100*min(scores.scores21fs),'%.1f') '/' num2str(100*max(scores.scores21fs),'%.1f') '] <<<']);
    end

    if isfield(corr,'corr12wp') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores12wp,scores.labels] = dice(M2.P(corr.corr12wp),M1.P);
        disp(['(Wp 1->2) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores12wp),'%.1f') '+-' num2str(100*std(scores.scores12wp),'%.1f') '% [' num2str(100*min(scores.scores12wp),'%.1f') '/' num2str(100*max(scores.scores12wp),'%.1f') ']']);
    end
    if isfield(corr,'corr21wp') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores21wp,scores.labels] = dice(M1.P(corr.corr21wp),M2.P);
        disp(['(Wp 2->1) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores21wp),'%.1f') '+-' num2str(100*std(scores.scores21wp),'%.1f') '% [' num2str(100*min(scores.scores21wp),'%.1f') '/' num2str(100*max(scores.scores21wp),'%.1f') ']']);
    end
    if isfield(corr,'corr12wp') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores12wp,scores.labels] = dice(M2.Pm(corr.corr12wp),M1.Pm);
        disp(['(Wp 1->2) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores12wp),'%.1f') '+-' num2str(100*std(scores.scores12wp),'%.1f') '% [' num2str(100*min(scores.scores12wp),'%.1f') '/' num2str(100*max(scores.scores12wp),'%.1f') ']']);
    end
    if isfield(corr,'corr21wp') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores21wp,scores.labels] = dice(M1.Pm(corr.corr21wp),M2.Pm);
        disp(['(Wp 2->1) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores21wp),'%.1f') '+-' num2str(100*std(scores.scores21wp),'%.1f') '% [' num2str(100*min(scores.scores21wp),'%.1f') '/' num2str(100*max(scores.scores21wp),'%.1f') ']']);
    end

    if isfield(corr,'corr12fc') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores12fc,scores.labels] = dice(M2.P(corr.corr12fc),M1.P);
        disp(['(Fc 1->2) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores12fc),'%.1f') '+-' num2str(100*std(scores.scores12fc),'%.1f') '% [' num2str(100*min(scores.scores12fc),'%.1f') '/' num2str(100*max(scores.scores12fc),'%.1f') ']']);
    end
    if isfield(corr,'corr21fc') && isfield(M1,'P') && isfield(M2,'P')
        [scores.scores21fc,scores.labels] = dice(M1.P(corr.corr21fc),M2.P);
        disp(['(Fc 2->1) Dice FS (avg+-std [min/max]): ' num2str(100*mean(scores.scores21fc),'%.1f') '+-' num2str(100*std(scores.scores21fc),'%.1f') '% [' num2str(100*min(scores.scores21fc),'%.1f') '/' num2str(100*max(scores.scores21fc),'%.1f') ']']);
    end
    if isfield(corr,'corr12fc') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores12fc,scores.labels] = dice(M2.Pm(corr.corr12fc),M1.Pm);
        disp(['(Fc 1->2) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores12fc),'%.1f') '+-' num2str(100*std(scores.scores12fc),'%.1f') '% [' num2str(100*min(scores.scores12fc),'%.1f') '/' num2str(100*max(scores.scores12fc),'%.1f') ']']);
    end
    if isfield(corr,'corr21fc') && isfield(M1,'Pm') && isfield(M2,'Pm')
        [scores.scores21fc,scores.labels] = dice(M1.Pm(corr.corr21fc),M2.Pm);
        disp(['(Fc 2->1) Dice Mn (avg+-std [min/max]): ' num2str(100*mean(scores.scores21fc),'%.1f') '+-' num2str(100*std(scores.scores21fc),'%.1f') '% [' num2str(100*min(scores.scores21fc),'%.1f') '/' num2str(100*max(scores.scores21fc),'%.1f') ']']);
    end

%     plot(1:numel(scores21), scores21', 'b-', 1:numel(scores21fs), scores21fs', 'r-')

    if do_display
        hold on; isolines(ls,ld,'k'); hold off;
        drawnow;
    end

    % Check negative Jacobians
    if isfield(corr,'corr12') && isfield(M1,'E') && isfield(M2,'E')
        dX1  = M2.E.X(corr.corr12,2:4) - M1.E.X(:,2:4);
        detJ = jacobian_field(M1.E.X(:,2:4), M1.F, dX1);
        scores.nneg12 = sum(detJ<0);  disp(['#nodes with neg |J| corr12: ' num2str(scores.nneg12)]);
    end
    if isfield(corr,'corr21') && isfield(M1,'E') && isfield(M2,'E')
        dX2  = M1.E.X(corr.corr21,2:4) - M2.E.X(:,2:4);
        detJ = jacobian_field(M2.E.X(:,2:4), M2.F, dX2);
        scores.nneg21 = sum(detJ<0);  disp(['#nodes with neg |J| corr21: ' num2str(scores.nneg21)]);
    end

end