% do_verbose(0|1 or more)
%    Global constant variable
%       Set with:    do_verbose(1);
%       Query with:  if do_verbose;  disp('verbose');  end;
%    Could also use various verbose level (e.g., do_verbose(4))
%
function o = do_verbose(i)
    persistent varval;
    if isempty(varval);  varval = 1;  end;
    if nargin>0;         varval = i;  end;
    if nargout==0;       return;      end;
    o = varval;
end
